//=============================================================================
// SwordAttachment
// Used by the ChaosUTMelee when we can not use the more ehnaced vrs
// of Melee combat.
// $Id: SwordAttachment.uc,v 1.2 2003/10/06 21:15:58 jb Exp $
//=============================================================================
class SwordAttachment extends xWeaponAttachment;

#exec AUDIO IMPORT FILE="hitfx1.WAV" NAME="hitfx1" GROUP="sword"
#exec AUDIO IMPORT FILE="hitfx2.WAV" NAME="hitfx2" GROUP="sword"
#exec AUDIO IMPORT FILE="hitfx3.WAV" NAME="hitfx3" GROUP="sword"
#exec AUDIO IMPORT FILE="hitfx4.WAV" NAME="hitfx4" GROUP="sword"
#exec AUDIO IMPORT FILE="hitfx5.WAV" NAME="hitfx5" GROUP="sword"

var byte OldSpawnHitCount;
var xEmitter lightningFX;
var int numEffects;

simulated function PostNetBeginPlay()
{
    setupRotation();
    SetTimer(1.0,true);
    super.PostNetBeginPlay();
}

function setupRotation()
{
    //necessary to rotate weapon to correct orientation. I could just remodel it, but i'm lazy
    
    local Rotator newRot;    // This will be our new Rotation
    
    newRot.Pitch = 32768;
    newRot.Yaw = 39152;
    newRot.Roll = 0;
    SetRelativeRotation (newRot);     // After we've done our tweaking go ahead and set the new rotation
}

simulated function timer ()
{
	/*if (rand(10) == 1)
	{
		if (numEffects < 5)
		{
			lightningFX = spawn(Class'xEffects.NewLightningBolt',self,,Location,Rotation);
			switch (rand(5))
			{
				case 1:
				PlaySound(Sound'sword.hitfx1', SLOT_None,128,,128,,true);
				break;
				case 2:
				PlaySound(Sound'sword.hitfx2', SLOT_None,128,,128,,true);
				break;
				case 3:
				PlaySound(Sound'sword.hitfx3', SLOT_None,128,,128,,true);
				break;
				case 4:
				PlaySound(Sound'sword.hitfx4', SLOT_None,128,,128,,true);
				break;
				case 5:
				PlaySound(Sound'sword.hitfx5', SLOT_None,128,,128,,true);
				break;
			}
			numEffects++;
		}
	}*/
}

simulated function Destroyed()
{
    Super.Destroyed();
}

/* UpdateHit
- used to update properties so hit effect can be spawn client side
*/
function UpdateHit(Actor HitActor, vector HitLocation, vector HitNormal)
{
    SpawnHitCount++;
    mHitLocation = HitLocation;
    mHitActor = HitActor;
    mHitNormal = HitNormal;
}

simulated event ThirdPersonEffects()
{

    if ( Level.NetMode != NM_DedicatedServer )
    {
        if (FiringMode == 0)
        {
            if ( OldSpawnHitCount != SpawnHitCount )
            {
                OldSpawnHitCount = SpawnHitCount;
                GetHitInfo();
                Spawn(class'HitEffect'.static.GetHitEffect(mHitActor, mHitLocation, mHitNormal),,, mHitLocation, Rotator(mHitNormal));
            }
        }
        else if (FiringMode == 1 && FlashCount > 0)
        {
            
        }
    }

    Super.ThirdPersonEffects();
}

defaultproperties
{
     DrawType=DT_StaticMesh
     DrawScale=1.0
     StaticMesh=StaticMesh'grabinSwordM.sword'
     numEffects=0
     //AmbientSound=Sound'GeneralAmbience.texture42'
     SoundOcclusion=OCCLUSION_BSP
     SoundRadius=128
     SoundVolume=255
     LightType=LT_SubtlePulse
     LightEffect=LE_NonIncidence
     LightHue=153
     LightSaturation=50
     LightBrightness=120
     LightRadius=5
     bActorShadows=True
     bDynamicLight=True
     bHeavy=True
}
