//=============================================================================
// swordFire
// Used by the s_Melee when we can not use the more ehnaced vrs
// of Melee combat.
// $Id: swordFire.uc,v 1.3 2003/10/06 23:26:27 jb Exp $
//=============================================================================
class swordFire extends WeaponFire;

var float WeaponRange;                  // from pawn centre
var int HeadShotDamageMult;
var() float HeadShotRadius;
var() class<DamageType> DamageTypeHeadShot;
var() class<DamageType> DamageTypeBotHeadShot;
var() class<DamageType> DamageTypeAlienHeadShot;
var() class<DamageType> DamageTypeBodyShot;
var float Momentum;
var int Damage;
var s_Spurt spurt;                    // blood effect for head shot -
// sounds
var sound melee_heatshot[2];
var sound melee_hitarmor[6];
var sound melee_hitflesh[5];
var sound sword_swing[5];
var int gotoRot;	//rotation number to go to. 0=base, 1=swing
var float animSpd;	//timer period for rotation anim

simulated function DestroyEffects()
{
	Super.DestroyEffects();
}

simulated function InitEffects()
{    
    Super.InitEffects();
        if ( FlashEmitter != None )
		Weapon.AttachToBone(FlashEmitter, 'tip');
	SetTimer(animSpd,true);	//animation timer, ie frames every 0.05sec
}


function Rotator AdjustAim(Vector Start, float InAimError)
{
	local rotator Aim, EnemyAim;

	if ( AIController(Instigator.Controller) != None )
	{
		Aim = Instigator.Rotation;
		if ( Instigator.Controller.Enemy != None )
		{
			EnemyAim = rotator(Instigator.Controller.Enemy.Location - Start);
			Aim.Pitch = EnemyAim.Pitch;
		}
		return Aim;
	}
	else
		return super.AdjustAim(Start,InAimError);
}


function DoFireEffect()
{

   local Vector HitLocation, HitNormal, StartTrace, EndTrace, X,Y,Z;
    local Rotator Aim;
	local Actor Other;
    local float Force;
    local float dist;

	Force = Momentum;
	Instigator.MakeNoise(1.0);
    	Weapon.GetViewAxes(X,Y,Z);
	StartTrace = Instigator.Location;
	Aim = AdjustAim(StartTrace, AimError);
	EndTrace = StartTrace + WeaponRange * Vector(Aim);
	Other = Weapon.Trace(HitLocation, HitNormal, EndTrace, StartTrace, true);

    if ( Other != None && Other != Instigator )
    {
    		if ( (Pawn(Other) != None) && Other.GetClosestBone( HitLocation, X, dist, 'head', HeadShotRadius ) == 'head' )
   		{
   			if ((XPawn(Other).GibGroupClass) == class'xbotgibgroup')
                 		XPawn(Other).TakeDamage(Damage * HeadShotDamageMult, Instigator, HitLocation, Force*x, DamageTypeBotHeadShot);// zero momentum for head shot
              		else IF ((XPawn(Other).GibGroupClass) == class'xAliengibgroup')
                 		XPawn(Other).TakeDamage(Damage * HeadShotDamageMult, Instigator, HitLocation, Force*x, DamageTypeAlienHeadShot);// zero momentum for head shot
              		else
                		XPawn(Other).TakeDamage(Damage * HeadShotDamageMult, Instigator, HitLocation, Force*x, DamageTypeHeadShot);// zero momentum for head shot
   		}
		else if ( Pawn(Other) != None || (Decoration(Other) != None && Decoration(Other).bDamageable) )
        		Other.TakeDamage(Damage, Instigator, HitLocation, Force*(X+vect(0,0,2)), DamageTypeBodyShot);
		else
		{
			if ( xPawn(Instigator).bBerserk )
				Force *= 2.0;
			//Instigator.TakeDamage(Damage, Instigator, HitLocation, -Force*X, DamageTypeBodyShot);
			if ( DestroyableObjective(Other) != None )
		      		Other.TakeDamage(Damage, Instigator, HitLocation, Force*(X+vect(0,0,0.5)), DamageTypeBodyShot);
		      	//WeaponAttachment(Weapon.ThirdPersonActor).UpdateHit(Other,HitLocation,HitNormal);
		}
    }
}


function bool IsFiring()
{
	return ( bIsFiring );
}



simulated function vector GetFireStart(vector X, vector Y, vector Z)
{
    return Instigator.Location;
}

function StartBerserk()
{
    Damage = default.Damage * 1.33;
    FireRate=default.FireRate* 0.8;
}

function StopBerserk()
{
    Damage = default.Damage;
    FireRate=default.FireRate;
}

function PlayPreFire()
{
	gotoRot = 1; //rotate to swing position
}

function PlayFireEnd()
{
}

simulated function timer ()
{
	local Rotator endAt, rotPerTick;    // This will be our new Rotation
	local SwordAttachment target;
	if (weapon.ThirdPersonActor != none)
	{
	target = SwordAttachment(weapon.ThirdPersonActor);
	if (gotoRot == 1)
	{
		if (target.RelativeRotation.Pitch != 32768 && target.RelativeRotation.Yaw != 39152
			&& target.RelativeRotation.Roll != 39152)
		{
			endAt.Pitch = 32768;
    			endAt.Yaw = 39152;
    			endAt.Roll = 39152;
    			rotPerTick.Pitch = target.RelativeRotation.Pitch - endAt.Pitch / animSpd;
    			rotPerTick.Yaw = target.RelativeRotation.Yaw - endAt.Yaw / animSpd;
    			rotPerTick.Roll = target.RelativeRotation.Roll - endAt.Roll / animSpd;
    			target.SetRelativeRotation(target.RelativeRotation + rotPerTick);
    		}
	}
	if (gotoRot == 0)
	{
		if (target.RelativeRotation.Pitch != 32768 && target.RelativeRotation.Yaw != 39152
			&& target.RelativeRotation.Roll != 0)
		{
			endAt.Pitch = 32768;
    			endAt.Yaw = 39152;
    			endAt.Roll = 0;
    			rotPerTick.Pitch = target.RelativeRotation.Pitch - endAt.Pitch / animSpd;
    			rotPerTick.Yaw = target.RelativeRotation.Yaw - endAt.Yaw / animSpd;
    			rotPerTick.Roll = target.RelativeRotation.Roll - endAt.Roll / animSpd;
    			target.SetRelativeRotation(target.RelativeRotation + rotPerTick);
    		}
	}
	}
}

// Next two were ripped from the weaponfire class
// in order to play a random sounds
function ServerPlayFiring()
{
    Weapon.PlayOwnedSound(sword_swing[Rand(5)],SLOT_Interact,TransientSoundVolume,,,,false);
}

function PlayFiring()
{
    if (FireCount > 0)
    {
        if (Weapon.HasAnim(FireLoopAnim))
        {
            Weapon.PlayAnim(FireLoopAnim, FireLoopAnimRate, 0.0);
        }
        else
        {
            Weapon.PlayAnim(FireAnim, FireAnimRate, TweenTime);
        }
    }
    else
    {
        Weapon.PlayAnim(FireAnim, FireAnimRate, TweenTime);
    }

    Weapon.PlayOwnedSound(sword_swing[Rand(5)],SLOT_Interact,TransientSoundVolume,,,,false);

    ClientPlayForceFeedback(FireForce);  // jdf

    FireCount++;
}

defaultproperties
{
     sword_swing(0)=none
     sword_swing(1)=none
     sword_swing(2)=none
     sword_swing(3)=none
     sword_swing(4)=none
     WeaponRange=150.000000
     Momentum=60000.000000
     HeadShotDamageMult=2.4
     HeadShotRadius=15.000000
     DamageTypeHeadShot=Class'DamTypeSwordHeadShot'
     DamageTypeBotHeadShot=Class'DamTypeBotSwordHeadShot'
     DamageTypeAlienHeadShot=Class'DamTypeAlienSwordHeadShot'
     DamageTypeBodyShot=Class'DamTypeSwordBodyShot'
     Damage=40
     TweenTime=0.000000
     FireForce="AssaultRifleFire"
     AmmoClass=Class'XWeapons.ShieldAmmo'
     ShakeRotMag=(X=50.000000,Y=50.000000,Z=50.000000)
     ShakeRotRate=(X=10000.000000,Y=10000.000000,Z=10000.000000)
     ShakeRotTime=2.000000
     ShakeOffsetMag=(X=1.000000,Y=1.000000,Z=1.000000)
     ShakeOffsetRate=(X=1000.000000,Y=1000.000000,Z=1000.000000)
     ShakeOffsetTime=2.000000
     TransientSoundVolume=1.000000
     melee_heatshot(0)=none
     melee_heatshot(1)=none
     Melee_HitArmor(0)=none
     Melee_HitArmor(1)=none
     Melee_HitArmor(2)=none
     Melee_HitArmor(3)=none
     Melee_HitArmor(4)=none
     Melee_HitArmor(5)=none
     Melee_HitFlesh(0)=none
     Melee_HitFlesh(1)=none
     Melee_HitFlesh(2)=none
     Melee_HitFlesh(3)=none
     Melee_HitFlesh(4)=none
     NoAmmoSound=ProceduralSound'WeaponSounds.PReload5.P1Reload5'
     bModeExclusive=True
     PreFireTime=0.2
     FireRate=0.7
     gotoRot=0
     animSpd=0.05
}
